"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _vm = _interopRequireDefault(require("vm"));

function clone(obj) {
  if (null == obj || 'object' != typeof obj) return obj;
  var copy = obj.constructor();

  for (var attr in obj) {
    if (obj.hasOwnProperty(attr)) copy[attr] = obj[attr];
  }

  return copy;
}

module.exports = function evalComponentCode(code) {
  try {
    const script = new _vm.default.Script(code, {}); // Fake require

    function fakeRequire() {}

    fakeRequire.default = fakeRequire;

    let requireSanbox = function (element) {
      // depending on the preset that one is running,
      // babel will not always use the root interopRequireDefault
      // for babel es6, it uses .../builtin/es6/interop...
      if (/@babel[\\,\/]runtime\/helpers\/.*interopRequireDefault$/.test(element)) {
        return function (value) {
          return value;
        };
      }

      if (element === 'vuex') {
        const outputVuex = {
          mapState: function () {},
          mapMutations: function () {},
          mapGetters: function () {},
          mapActions: function () {},
          createNamespacedHelpers: function () {}
        };
        return (0, _objectSpread2.default)({}, outputVuex, {
          default: outputVuex
        });
      }

      if (element === 'vue') {
        const outputVue = {
          __esModule: true,
          use: function use() {},
          directive: function use() {},
          component: function component() {},
          extended: function extended() {},

          extend(obj) {
            return obj;
          }

        };
        return (0, _objectSpread2.default)({}, outputVue, {
          default: outputVue
        });
      }

      return fakeRequire;
    };

    requireSanbox.context = function () {
      return function () {};
    };

    const sandbox = {
      exports: {},
      module: {
        exports: {}
      },
      require: requireSanbox,
      document: {},
      window: {
        location: {}
      },

      alert() {},

      confirm() {},

      console: {
        log() {},

        debug() {}

      },
      sessionStorage: {
        getItem() {},

        setItem() {},

        removeItem() {}

      },
      localStorage: {
        getItem() {},

        setItem() {},

        removeItem() {}

      }
    };
    const context = new _vm.default.createContext(sandbox);
    script.runInContext(context);
    const output = sandbox;
    return clone(output);
  } catch (err) {
    throw err;
  }
};